<?php

namespace Ulmus\Api\Gitea;

use Psr\Http\Message\{ RequestInterface, ResponseInterface };
use Ulmus\Api\ApiHandlerInterface;
use Ulmus\Api\Common\ApiHandlerPassThrough;
use Ulmus\Api\Response\JsonResponse;

class ApiHandler extends ApiHandlerPassThrough
{
    public function handleResponse(ResponseInterface $response, \Ulmus\Api\Attribute\Obj\Api\ApiAction $attribute) : ResponseInterface
    {
        $json = $response->getParsedBody();

        if ($json['message'] ?? false) {
            if ( array_key_exists('errors', $json) && null === $json['errors'] ?? null) {
#                if ($attribute instanceof \Ulmus\Api\Attribute\Obj\Api\Collection) {
#                    return [];
#                }
#                elseif ($attribute instanceof \Ulmus\Api\Attribute\Obj\Api\Read) {
#                    return null;
#                }
#                elseif ($attribute instanceof \Ulmus\Api\Attribute\Obj\Api\Create) {
#                    return false;
#                }
            }

            throw new \Exception($json['message']);
        }

        return JsonResponse::fromResponse($response)->withParsedBody($json);
    }
}